	IFND DEVICES_AHI_I
DEVICES_AHI_I		SET	1

**
**	$VER: ahi.i 2.1 (21.5.96)
**
**	ahi.device definitions
**
**	(C) Copyright 1994-1996 Martin Blom
**	All Rights Reserved.
**
** (TAB SIZE: 8)
**

*------------------------------------------------------------------------*


	IFND EXEC_TYPES_I
	INCLUDE 'exec/types.i'
	ENDC

	IFND EXEC_LIBRARIES_I
	INCLUDE 'exec/io.i'
	ENDC

	IFND UTILITY_TAGITEM_I
	INCLUDE 'utility/tagitem.i'
	ENDC

*------------------------------------------------------------------------*

 * Device units

AHI_FIRST_UNIT	EQU	0
AHI_NO_UNIT	EQU	255

 * AHIRequest
	STRUCTURE AHIRequest,0
	STRUCT	ahir_Std,IOSTD_SIZE		* Standard IO request
	UWORD	ahir_Version			* Needed version
	LABEL	AHIRequest_SIZEOF

*- FUNCTION INTERFACE DEFINITIONS FOLLOWS -------------------------------*

*** MACROS

AHINAME	MACRO
	dc.b	"ahi.device",0
	ENDM

 * A handy macro to open the device for use as a library.
 * Useage:  OPENAHI <version>
 * On exit: d0=_AHIBase or NULL for error.

OPENAHI	MACRO
	movem.l	d1/a0-a1/a6,-(sp)
	lea	AHI_PORT(pc),a0
	clr.l	(a0)+
	clr.l	(a0)+
	moveq	#0,d0
	move.l	d0,(a0)+

	move.l	4.w,a6
	jsr	_LVOCreateMsgPort(a6)
	lea	AHI_PORT(pc),a0
	move.l	d0,(a0)
	beq.b	AHI_ERROR
	move.l	d0,a0
	moveq	#AHIRequest_SIZEOF,d0
	jsr	_LVOCreateIORequest(a6)
	lea	AHI_IOR(pc),a0
	move.l	d0,(a0)
	beq.b	AHI_ERROR
	lea	AHI_NAME(pc),a0
	move.l	d0,a1
	move.w	#\1,ahir_Version(a1)
	move.l	#AHI_NO_UNIT,d0
	moveq	#0,d1
	jsr	_LVOOpenDevice(a6)
	lea	AHI_DEVICE(pc),a0
	move.l	d0,(a0)
	bne.b	AHI_ERROR

	move.l	AHI_IOR(PC),a0
	move.l	IO_DEVICE(a0),d0
	bra.b	AHI_EXIT

AHI_PORT:	dc.l	0
AHI_IOR:	dc.l	0
AHI_DEVICE:	dc.l	0
AHI_NAME:	AHINAME
	even
AHI_ERROR:
	moveq	#0,D0
AHI_EXIT:
	movem.l	(sp)+,d1/a0-a1/a6
	ENDM

 * Here is the macro for closing the device after it has been
 * opened with the OPENAHI macro. Call CLOSEAHI even if OPENAHI
 * failed!

CLOSEAHI MACRO
	movem.l	d0-d1/a0-a1/a6,-(sp)
	move.l	4.w,a6
	lea	AHI_DEVICE(pc),a1
	tst.l	(a1)
	bne.b	.ahi_nodevice
	subq.l	#1,(a1)
	move.l	AHI_IOR(pc),a1
	jsr	_LVOCloseDevice(a6)
	lea	AHI_IOR(pc),a1
	move.l	(a1),a0
	clr.l	(a1)
	jsr	_LVODeleteIORequest(a6)
.ahi_nodevice
	lea	AHI_PORT(pc),a1
	move.l	(a1),a0
	clr.l	(a1)
	jsr	_LVODeleteMsgPort(a6)
	movem.l	(sp)+,d0-d1/a0-a1/a6
	ENDM
 
*** STRUCTURES

 * AHIAudioCtrl
	STRUCTURE AHIAudioCtrl,0
	APTR	ahiac_UserData
	* Lots of private data follows!
	LABEL	AHIAudioCtrl_SIZEOF		* Do not use!

 * AHISoundMessage
 	STRUCTURE AHISoundMessage,0
 	UWORD	ahism_Channel
 	LABEL	AHISoundMessage_SIZEOF

 * AHIRecordMessage
	STRUCTURE AHIRecordMessage,0
	ULONG	ahirm_Type			* Format of buffer (object)
	APTR	ahirm_Buffer			* Pointer to the sample array
	ULONG	ahirm_Length			* Number of sample frames in buffer
	LABEL	AHIRecordMessage_SIZEOF

 * AHISampleInfo
	STRUCTURE AHISampleInfo,0
	ULONG	ahisi_Type			* Format of samples
	APTR	ahisi_Address			* Address to array of samples
	ULONG	ahisi_Length			* Number of samples in array
	LABEL	AHISampleInfo_SIZEOF

*
* An array of AHIMultiLoop structures are used to describe how to play multi-
* looped sounds. ahiml_Command can be a number from 1 to 65535 to play the
* segment that number of times before proceeding to the next structure in the
* array, or 0 to play the segment forever (terminating the array). If
* the last ahiml_Command in the array is ~0 the sound will be stopped
* (ahiml_Offset and ahiml_Length should be set to 0 in this case).
*

 * AHIMultiLoop
	STRUCTURE AHIMultiLoop,0
	ULONG	ahisl_Command
	ULONG	ahisl_Offset			* Offset in samples
	ULONG	ahisl_Length			* Length in samples
	LABEL	AHIMultiLoop_SIZEOF

 * AHILoopInfo (size is variable)
 	STRUCTURE AHILoopInfo,0
 	UWORD	ahili_Sound			* The source sound
 	UWORD	ahili_Pad
 	STRUCT	ahili_LoopArray,AHIMultiLoop_SIZEOF


 * AHIAudioModeRequester
	STRUCTURE AHIAudioModeRequester,0
	ULONG	ahiam_AudioID;			* Selected audio mode
	ULONG	ahiam_MixFreq;			* Selected mixing/sampling frequency
	
	WORD	ahiam_LeftEdge;			* Coordinates of requester on exit
	WORD	ahiam_TopEdge;
	WORD	ahiam_Width;
	WORD	ahiam_Height;

	BOOL	ahiam_InfoOpened;		* Info window opened on exit
	WORD	ahiam_InfoLeftEdge;		* Last coordinates of Info window
	WORD	ahiam_InfoTopEdge;
	WORD	ahiam_InfoWidth;
	WORD	ahiam_InfoHeight;

	APTR	ahiam_UserData;			* You can store your own data here
	LABEL	AHIAudioModeRequester_SIZEOF

ahie_Effect	EQU	0

 * AHIEffMasterVolume
	STRUCTURE AHIEffMasterVolume,4
;	ULONG	ahie_Effect			* Set to AHIET_MASTERVOLUME
	LONG	ahiemv_Volume			* (Fixed) See autodocs for range!
	LABEL	AHIEffMasterVolume_SIZEOF

 * AHIEffOutputBuffer
	STRUCTURE AHIEffOutputBuffer,4
;	ULONG	ahie_Effect			* Set to AHIET_OUTPUTBUFFER
	APTR	ahieob_Func
 * These fields are filled by AHI
	ULONG	ahieob_Type			* Format of buffer
	APTR	ahieob_Buffer			* Pointer to the sample array
	ULONG	ahieob_Length			* Number of sample frames in buffer
	LABEL	AHIEffOutputBuffer_SIZEOF

*** TAGS

AHI_TagBase		EQU TAG_USER
AHI_TagBaseR		EQU AHI_TagBase|$8000

 * AHI_AllocAudioA tags
AHIA_AudioID		EQU AHI_TagBase+1	* Desired audio mode
AHIA_MixFreq		EQU AHI_TagBase+2	* Suggested mixing frequency
AHIA_Channels		EQU AHI_TagBase+3	* Suggested number of channels
AHIA_Sounds		EQU AHI_TagBase+4	* Number of sounds to use
AHIA_SoundFunc		EQU AHI_TagBase+5	* End-of-Sound Hook
AHIA_PlayerFunc		EQU AHI_TagBase+6	* Player Hook
AHIA_PlayerFreq		EQU AHI_TagBase+7	* Frequency for player Hook
AHIA_MinPlayerFreq	EQU AHI_TagBase+8	* Minimum Frequency for player Hook
AHIA_MaxPlayerFreq	EQU AHI_TagBase+9	* Maximum Frequency for player Hook
AHIA_RecordFunc		EQU AHI_TagBase+10	* Sample recording Hook
AHIA_UserData		EQU AHI_TagBase+11	* What to put in ahiac_UserData

 * AHI_ControlAudioA tags
AHIC_Play		EQU AHI_TagBase+80	* Boolean
AHIC_Record		EQU AHI_TagBase+81	* Boolean
AHIC_MonitorVolume	EQU AHI_TagBase+82
AHIC_MonitorVolume_Query EQU AHI_TagBase+83	* ti_Data is pointer to Fixed (LONG)
AHIC_MixFreq_Query	EQU AHI_TagBase+84	* ti_Data is pointer to ULONG
* --- New for V2, they will be ignored by V1 --- */
AHIC_InputGain		EQU AHI_TagBase+85
AHIC_InputGain_Query	EQU AHI_TagBase+86	* ti_Data is pointer to Fixed (LONG)
AHIC_OutputVolume	EQU AHI_TagBase+87
AHIC_OutputVolume_Query	EQU AHI_TagBase+88	* ti_Data is pointer to Fixed (LONG)
AHIC_Input		EQU AHI_TagBase+89
AHIC_Input_Query	EQU AHI_TagBase+90	* ti_Data is pointer to ULONG
AHIC_Output		EQU AHI_TagBase+91
AHIC_Output_Query	EQU AHI_TagBase+92	* ti_Data is pointer to ULONG

 * AHI_GetAudioAttrsA tags
AHIDB_AudioID		EQU AHI_TagBase+100	* Private!
AHIDB_Driver		EQU AHI_TagBaseR+101	* Pointer to name of driver
AHIDB_Flags		EQU AHI_TagBase+102	* Private!
AHIDB_Volume		EQU AHI_TagBase+103	* Boolean
AHIDB_Panning		EQU AHI_TagBase+104	* Boolean
AHIDB_Stereo		EQU AHI_TagBase+105	* Boolean
AHIDB_HiFi		EQU AHI_TagBase+106	* Boolean
AHIDB_PingPong		EQU AHI_TagBase+107	* Boolean
AHIDB_MultTable		EQU AHI_TagBase+108	* Private!
AHIDB_Name		EQU AHI_TagBaseR+109	* Pointer to name of this mode
AHIDB_Bits		EQU AHI_TagBase+110	* Output bits
AHIDB_MaxChannels	EQU AHI_TagBase+111	* Max supported channels
AHIDB_MinMixFreq	EQU AHI_TagBase+112	* Min mixing freq. supported
AHIDB_MaxMixFreq	EQU AHI_TagBase+113	* Max mixing freq. supported
AHIDB_Record		EQU AHI_TagBase+114	* Boolean
AHIDB_Frequencies	EQU AHI_TagBase+115
AHIDB_FrequencyArg	EQU AHI_TagBase+116	* ti_Data is index number!
AHIDB_Frequency		EQU AHI_TagBase+117
AHIDB_Author		EQU AHI_TagBase+118	* Pointer to driver author name
AHIDB_Copyright		EQU AHI_TagBase+119	* Pointer to driver copyright notice
AHIDB_Version		EQU AHI_TagBase+120	* Pointer to driver version string
AHIDB_Annotation	EQU AHI_TagBase+121	* Pointer to driver annotation text
AHIDB_IndexArg		EQU AHI_TagBase+123	* ti_Data is frequency!
AHIDB_BufferLen		EQU AHI_TagBase+122	* Specifies the string buffer size
AHIDB_Index		EQU AHI_TagBase+124
AHIDB_Realtime		EQU AHI_TagBase+125	* Boolean
AHIDB_MaxPlaySamples	EQU AHI_TagBase+126	* It's sample *frames*
AHIDB_MaxRecordSamples	EQU AHI_TagBase+127	* It's sample *frames*
AHIDB_MixFreq	   	EQU AHI_TagBase+128
AHIDB_FullDuplex	EQU AHI_TagBase+129	* Boolean
* --- New for V2, they will be ignored by V1 ---
AHIDB_MinMonitorVolume	EQU AHI_TagBase+130
AHIDB_MaxMonitorVolume	EQU AHI_TagBase+131
AHIDB_MinInputGain	EQU AHI_TagBase+132
AHIDB_MaxInputGain	EQU AHI_TagBase+133
AHIDB_MinOutputVolume	EQU AHI_TagBase+134
AHIDB_MaxOutputVolume	EQU AHI_TagBase+135
AHIDB_Inputs		EQU AHI_TagBase+136
AHIDB_InputArg		EQU AHI_TagBase+137	* ti_Data is input index
AHIDB_Input		EQU AHI_TagBase+138
AHIDB_Outputs		EQU AHI_TagBase+139
AHIDB_OutputArg		EQU AHI_TagBase+140	* ti_Data is input index
AHIDB_Output		EQU AHI_TagBase+141

 * AHI_AudioRequestA tags
   * Window control
AHIR_Window		EQU AHI_TagBase+200	* Parent window
AHIR_Screen		EQU AHI_TagBase+201	* Screen to open on if no window
AHIR_PubScreenName	EQU AHI_TagBase+202	* Name of public screen
AHIR_PrivateIDCMP	EQU AHI_TagBase+203	* Allocate private IDCMP?
AHIR_IntuiMsgFunc	EQU AHI_TagBase+204	* Function to handle IntuiMessages
AHIR_SleepWindow	EQU AHI_TagBase+205	* Block input in AHIR_Window?
AHIR_UserData		EQU AHI_TagBase+206	* What to put in ahiam_UserData
   * Text display
AHIR_TextAttr		EQU AHI_TagBase+220	* Text font to use for gadget text
AHIR_Locale		EQU AHI_TagBase+221	* Locale to use for text
AHIR_TitleText		EQU AHI_TagBase+222	* Title of requester
AHIR_PositiveText	EQU AHI_TagBase+223	* Positive gadget text
AHIR_NegativeText	EQU AHI_TagBase+224	* Negative gadget text
   * Initial settings
AHIR_InitialLeftEdge	EQU AHI_TagBase+240	* Initial requester coordinates
AHIR_InitialTopEdge	EQU AHI_TagBase+241
AHIR_InitialWidth 	EQU AHI_TagBase+242	* Initial requester dimensions
AHIR_InitialHeight	EQU AHI_TagBase+243
AHIR_InitialAudioID	EQU AHI_TagBase+244	* Initial audio mode id
AHIR_InitialMixFreq	EQU AHI_TagBase+245	* Initial mixing/sampling frequency
AHIR_InitialInfoOpened	EQU AHI_TagBase+246	* Info window initially opened?
AHIR_InitialInfoLeftEdge EQU AHI_TagBase+247	* Initial Info window coords.
AHIR_InitialInfoTopEdge	EQU AHI_TagBase+248
AHIR_InitialInfoWidth	EQU AHI_TagBase+249
AHIR_InitialInfoHeight	EQU AHI_TagBase+250
   * Options
AHIR_DoMixFreq		EQU AHI_TagBase+260	* Allow selection of mixing frequency?
   * Filtering
AHIR_FilterTags		EQU AHI_TagBase+270	* Pointer to filter taglist
AHIR_FilterFunc		EQU AHI_TagBase+271	* Function to filter mode id's


*** DEFS

AHI_INVALID_ID		EQU ~0			* Invalid Audio ID
AHI_DEFAULT_ID		EQU $00000000		* Only for AHI_AllocAudioA()!
AHI_LOOPBACK_ID		EQU $00000001		* Special sample render ID
AHI_DEFAULT_FREQ	EQU 0			* Only for AHI_AllocAudioA()!
AHI_MIXFREQ		EQU ~0			* Special frequency for AHI_SetFreq()
AHI_NOSOUND		EQU ~0			* Turns a channel off

 * Set#? Flags
	BITDEF	AHIS,IMM,0

 * Effect types
AHIET_CANCEL		EQU 1<<31		* OR with effect to disable
AHIET_MASTERVOLUME	EQU 1
AHIET_OUTPUTBUFFER	EQU 2

 * Sound types
AHIST_NOTYPE		EQU ~0			* Private
AHIST_SAMPLE		EQU 0			* 8 or 16 bit sample
AHIST_DYNAMICSAMPLE	EQU 1			* Dynamic sample
AHIST_BW		EQU 2			* Private
AHIST_INPUT		EQU 257			* The input from your sampler
AHIST_LOOP		EQU 1<<31		* Multi-loop sound

 * Sample types
* Note that only AHIST_M8S, AHIST_M8U and AHIST_M16S
* are supported by AHI_LoadSound().
AHIST_M8S		EQU 0			* Mono, 8 bit signed (BYTE)
AHIST_M16S		EQU 1			* Mono, 16 bit signed (WORD)
AHIST_S16S		EQU 3			* Stereo, 16 bit signed (2WORD)
AHIST_M8U		EQU 4			* Mono, 8 bit unsigned (UBYTE)
AHIST_M32S		EQU 8			* Mono, 32 bit signed (LONG)
AHIST_S32S		EQU 10			* Stereo, 32 bit signed (2LONG)

 * Error codes
AHIE_OK			EQU 0			* No error
AHIE_NOMEM		EQU 1			* Out of memory
AHIE_BADSOUNDTYPE	EQU 2			* Unknown sound type
AHIE_BADSAMPLETYPE	EQU 3			* Unknown/unsupported sample type
AHIE_ABORTED		EQU 4			* User-triggered abortion

	ENDC ; DEVICES_AHI_I
